function resetRegisterButtons () {
  if (this.readingContinuously === true || this.readingFaultStatusRegistersContinuously === true  || this.readingMotorStatusRegistersContinuously === true) {
    this.readingContinuously = false;
    this.readingFaultStatusRegistersContinuously = false;
    this.readingMotorStatusRegistersContinuously = false;
    updateButtonStyles(this);
  }
}

function openPopup() {
  resetRegisterButtons.call(this);
  this.$.ti_nvm_widget_dialog.open();
}

function closePopup() {
  this.$.ti_nvm_widget_dialog.close();
}

function nvmLoad() {
  if (arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.loadNVM();
}

function verifyNvm() {
  if (arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.verifyNVM();
}

function retryNvm() {
  if (arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.retryNVM();
}

function cancelNvm() {
  if (arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.cancelNVM();
}

function closeNVM() {
  this.$.ti_mdbu_file_nvmprogrammer.resetTab();
  this.$.ti_nvm_widget_dialog.close();
}

function updateMaximumSpeedControl() {
  var max_speed = gc.databind.registry.getBinding('props.calculation_value_MaximumSpeed').getValue();
  gc.databind.registry.getBinding('props.value_MaxSpeed').setValue(max_speed);
}

function updateAbnormalSpeedThresholdControl() {
  var abn_speed_thr = gc.databind.registry.getBinding('props.calculation_value_AbnormalSpeedThreshold').getValue();
  var index_lock_abn_thr;
  if (abn_speed_thr <= 250)
  {
      index_lock_abn_thr = 0;
  } else if (abn_speed_thr > 250 && abn_speed_thr <= 500)
  {
      index_lock_abn_thr = 1;
  } else if (abn_speed_thr > 500 && abn_speed_thr <= 750)
  {
      index_lock_abn_thr = 2;
  } else if (abn_speed_thr > 750 && abn_speed_thr <= 1000)
  {
      index_lock_abn_thr = 3;
  } else if (abn_speed_thr > 1000 && abn_speed_thr <= 1250)
  {
      index_lock_abn_thr = 4;
  } else if (abn_speed_thr > 1250 && abn_speed_thr <= 1500)
  {
      index_lock_abn_thr = 5;
  } else if (abn_speed_thr > 1500 && abn_speed_thr <= 1750)
  {
      index_lock_abn_thr = 6;
  } else if (abn_speed_thr > 1750 && abn_speed_thr <= 2000)
  {
      index_lock_abn_thr = 7;
  } else if (abn_speed_thr > 2000 && abn_speed_thr <= 2250)
  {
      index_lock_abn_thr = 8;
  } else if (abn_speed_thr > 2250 && abn_speed_thr <= 2500)
  {
      index_lock_abn_thr = 9;
  } else if (abn_speed_thr > 2500 && abn_speed_thr <= 2750)
  {
      index_lock_abn_thr = 10;
  } else if (abn_speed_thr > 2750 && abn_speed_thr <= 3000)
  {
      index_lock_abn_thr = 11;
  } else if (abn_speed_thr > 3000 && abn_speed_thr <= 3250)
  {
      index_lock_abn_thr = 12;
  } else if (abn_speed_thr > 3250 && abn_speed_thr <= 3500)
  {
      index_lock_abn_thr = 13;
  } else if (abn_speed_thr > 3500 && abn_speed_thr <= 3750)
  {
      index_lock_abn_thr = 14;
  } else if (abn_speed_thr > 3750)
  {
      index_lock_abn_thr = 15;
  }
  gc.databind.registry.getBinding('my_model.FAULT_CONFIG2.LOCK_ABN_SPEED').setValue(index_lock_abn_thr);
}

function updateIlimitValueControl() {
  var ilimit_value = gc.databind.registry.getBinding('props.calculation_value_IlimitValue').getValue();
  var index_ilimit;
  if (ilimit_value <= 0.1)
  {
      index_ilimit = 1;
  } else if (ilimit_value > 0.1 && ilimit_value <= 0.2)
  {
      index_ilimit = 2;
  } else if (ilimit_value > 0.2 && ilimit_value <= 0.3)
  {
      index_ilimit = 3;
  } else if (ilimit_value > 0.3 && ilimit_value <= 0.4)
  {
      index_ilimit = 4;
  } else if (ilimit_value > 0.4 && ilimit_value <= 0.5)
  {
      index_ilimit = 5;
  } else if (ilimit_value > 0.5 && ilimit_value <= 0.6)
  {
      index_ilimit = 6;
  } else if (ilimit_value > 0.6 && ilimit_value <= 0.7)
  {
      index_ilimit = 7;
  } else if (ilimit_value > 0.7 && ilimit_value <= 0.8)
  {
      index_ilimit = 8;
  } else if (ilimit_value > 0.8 && ilimit_value <= 0.9)
  {
      index_ilimit = 9;
  } else if (ilimit_value > 0.9 && ilimit_value <= 1.0)
  {
      index_ilimit = 10;
  } else if (ilimit_value > 1.0 && ilimit_value <= 1.1)
  {
      index_ilimit = 11;
  } else if (ilimit_value > 1.1 && ilimit_value <= 1.2)
  {
      index_ilimit = 12;
  } else if (ilimit_value > 1.2 && ilimit_value <= 1.3)
  {
      index_ilimit = 13;
  } else if (ilimit_value > 1.3 && ilimit_value <= 1.4)
  {
      index_ilimit = 14;
  } else if (ilimit_value > 1.4)
  {
      index_ilimit = 15;
  }
  gc.databind.registry.getBinding('my_model.FAULT_CONFIG1.ILIMIT').setValue(index_ilimit);
}

function updateIpdCurrentThresholdControl() {
  var ipd_curr_thr_value = gc.databind.registry.getBinding('props.calculation_value_IpdCurrentThreshold_V').getValue();
  var index_ipd_curr_thr;
  if (ipd_curr_thr_value <= 0.2)
  {
      index_ipd_curr_thr = 2;
  } else if (ipd_curr_thr_value > 0.2 && ipd_curr_thr_value <= 0.3)
  {
      index_ipd_curr_thr = 3;
  } else if (ipd_curr_thr_value > 0.3 && ipd_curr_thr_value <= 0.4)
  {
      index_ipd_curr_thr = 4;
  } else if (ipd_curr_thr_value > 0.4 && ipd_curr_thr_value <= 0.5)
  {
      index_ipd_curr_thr = 5;
  } else if (ipd_curr_thr_value > 0.5 && ipd_curr_thr_value <= 0.6)
  {
      index_ipd_curr_thr = 6;
  } else if (ipd_curr_thr_value > 0.6 && ipd_curr_thr_value <= 0.7)
  {
      index_ipd_curr_thr = 7;
  } else if (ipd_curr_thr_value > 0.7 && ipd_curr_thr_value <= 0.8)
  {
      index_ipd_curr_thr = 8;
  } else if (ipd_curr_thr_value > 0.8 && ipd_curr_thr_value <= 0.9)
  {
      index_ipd_curr_thr = 9;
  } else if (ipd_curr_thr_value > 0.9 && ipd_curr_thr_value <= 1.0)
  {
      index_ipd_curr_thr = 10;
  } else if (ipd_curr_thr_value > 1.0 && ipd_curr_thr_value <= 1.1)
  {
      index_ipd_curr_thr = 11;
  } else if (ipd_curr_thr_value > 1.1 && ipd_curr_thr_value <= 1.2)
  {
      index_ipd_curr_thr = 12;
  } else if (ipd_curr_thr_value > 1.2 && ipd_curr_thr_value <= 1.3)
  {
      index_ipd_curr_thr = 13;
  } else if (ipd_curr_thr_value > 1.3 && ipd_curr_thr_value <= 1.4)
  {
      index_ipd_curr_thr = 14;
  } else if (ipd_curr_thr_value > 1.4)
  {
      index_ipd_curr_thr = 15;
  }
  gc.databind.registry.getBinding('my_model.MOTOR_STARTUP1.IPD_CURR_THR').setValue(index_ipd_curr_thr);
}

function updateAlignCurrentThresholdControl() {
  var align_curr_thr_value = gc.databind.registry.getBinding('props.calculation_value_AlignCurrentThreshold_V').getValue();
  var index_align_curr_thr;
  if (align_curr_thr_value <= 0.1)
  {
      index_align_curr_thr = 1;
  } else if (align_curr_thr_value > 0.1 && align_curr_thr_value <= 0.2)
  {
      index_align_curr_thr = 2;
  } else if (align_curr_thr_value > 0.2 && align_curr_thr_value <= 0.3)
  {
      index_align_curr_thr = 3;
  } else if (align_curr_thr_value > 0.3 && align_curr_thr_value <= 0.4)
  {
      index_align_curr_thr = 4;
  } else if (align_curr_thr_value > 0.4 && align_curr_thr_value <= 0.5)
  {
      index_align_curr_thr = 5;
  } else if (align_curr_thr_value > 0.5 && align_curr_thr_value <= 0.6)
  {
      index_align_curr_thr = 6;
  } else if (align_curr_thr_value > 0.6 && align_curr_thr_value <= 0.7)
  {
      index_align_curr_thr = 7;
  } else if (align_curr_thr_value > 0.7 && align_curr_thr_value <= 0.8)
  {
      index_align_curr_thr = 8;
  } else if (align_curr_thr_value > 0.8 && align_curr_thr_value <= 0.9)
  {
      index_align_curr_thr = 9;
  } else if (align_curr_thr_value > 0.9 && align_curr_thr_value <= 1.0)
  {
      index_align_curr_thr = 10;
  } else if (align_curr_thr_value > 1.0 && align_curr_thr_value <= 1.1)
  {
      index_align_curr_thr = 11;
  } else if (align_curr_thr_value > 1.1 && align_curr_thr_value <= 1.2)
  {
      index_align_curr_thr = 12;
  } else if (align_curr_thr_value > 1.2 && align_curr_thr_value <= 1.3)
  {
      index_align_curr_thr = 13;
  } else if (align_curr_thr_value > 1.3 && align_curr_thr_value <= 1.4)
  {
      index_align_curr_thr = 14;
  } else if (align_curr_thr_value > 1.4)
  {
      index_align_curr_thr = 15;
  }
  gc.databind.registry.getBinding('my_model.MOTOR_STARTUP1.ALIGN_CURR_THR').setValue(index_align_curr_thr);
}

function updateFastDecelCurrentThresholdControl() {
  var fast_decel_curr_thr_value = gc.databind.registry.getBinding('props.calculation_value_FastDecelCurrentThreshold_V').getValue();
  var index_fast_decel_curr_thr;
  if (fast_decel_curr_thr_value <= 0.1)
  {
      index_fast_decel_curr_thr = 1;
  } else if (fast_decel_curr_thr_value > 0.1 && fast_decel_curr_thr_value <= 0.2)
  {
      index_fast_decel_curr_thr = 2;
  } else if (fast_decel_curr_thr_value > 0.2 && fast_decel_curr_thr_value <= 0.3)
  {
      index_fast_decel_curr_thr = 3;
  } else if (fast_decel_curr_thr_value > 0.3 && fast_decel_curr_thr_value <= 0.4)
  {
      index_fast_decel_curr_thr = 4;
  } else if (fast_decel_curr_thr_value > 0.4 && fast_decel_curr_thr_value <= 0.5)
  {
      index_fast_decel_curr_thr = 5;
  } else if (fast_decel_curr_thr_value > 0.5 && fast_decel_curr_thr_value <= 0.6)
  {
      index_fast_decel_curr_thr = 6;
  } else if (fast_decel_curr_thr_value > 0.6 && fast_decel_curr_thr_value <= 0.7)
  {
      index_fast_decel_curr_thr = 7;
  } else if (fast_decel_curr_thr_value > 0.7 && fast_decel_curr_thr_value <= 0.8)
  {
      index_fast_decel_curr_thr = 8;
  } else if (fast_decel_curr_thr_value > 0.8 && fast_decel_curr_thr_value <= 0.9)
  {
      index_fast_decel_curr_thr = 9;
  } else if (fast_decel_curr_thr_value > 0.9 && fast_decel_curr_thr_value <= 1.0)
  {
      index_fast_decel_curr_thr = 10;
  } else if (fast_decel_curr_thr_value > 1.0 && fast_decel_curr_thr_value <= 1.1)
  {
      index_fast_decel_curr_thr = 11;
  } else if (fast_decel_curr_thr_value > 1.1 && fast_decel_curr_thr_value <= 1.2)
  {
      index_fast_decel_curr_thr = 12;
  } else if (fast_decel_curr_thr_value > 1.2 && fast_decel_curr_thr_value <= 1.3)
  {
      index_fast_decel_curr_thr = 13;
  } else if (fast_decel_curr_thr_value > 1.3 && fast_decel_curr_thr_value <= 1.4)
  {
      index_fast_decel_curr_thr = 14;
  } else if (fast_decel_curr_thr_value > 1.4)
  {
      index_fast_decel_curr_thr = 15;
  }
  gc.databind.registry.getBinding('my_model.CLOSED_LOOP3.FAST_DECEL_CURR_LIM').setValue(index_fast_decel_curr_thr);
}

function updatePhaseResistance() {
  var phase_resistane = gc.databind.registry.getBinding('props.calculation_value_PhaseResistance').getValue();
  gc.databind.registry.getBinding('props.calculation_value_MotorPhaseResistanceInput').setValue(phase_resistane);
  this.$.ti_adv_tuning_mdbu_custom_numberbox_component24.fire('change');
}

function updateMotorBemfConstant() {
  var bemf_constant = gc.databind.registry.getBinding('props.calculation_value_BemfResult').getValue();
  gc.databind.registry.getBinding('props.calculation_value_MotorPhaseBEMFConstantInput').setValue(bemf_constant);
  this.$.ti_adv_tuning_mdbu_custom_numberbox_component26.fire('change');
}

function updateMotorBemfConstant2() {
  var bemf_constant = gc.databind.registry.getBinding('props.calculation_value_BemfResult2').getValue();
  gc.databind.registry.getBinding('props.calculation_value_MotorPhaseBEMFConstantInput').setValue(bemf_constant);
  this.$.ti_adv_tuning_mdbu_custom_numberbox_component26.fire('change');
}

function updateMotorBemfConstant3() {
  var bemf_constant = gc.databind.registry.getBinding('props.calculation_value_BemfResult3').getValue();
  gc.databind.registry.getBinding('props.calculation_value_MotorPhaseBEMFConstantInput').setValue(bemf_constant);
  this.$.ti_adv_tuning_mdbu_custom_numberbox_component26.fire('change');
}

function updateSpeedLoopKp() {
  var speed_loop_kp = gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKp').getValue();
  gc.databind.registry.getBinding('my_model.CLOSED_LOOP4.SPD_LOOP_KP').setValue(speed_loop_kp);
}

function updateSpeedLoopKi() {
  var speed_loop_ki = gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKi').getValue();
  gc.databind.registry.getBinding('my_model.CLOSED_LOOP4.SPD_LOOP_KI').setValue(speed_loop_ki);
}

function navToVtabContainer() {
  this.$.ti_basic_tuning_widget_tabcontainer.selectedIndex = 1;
  this.$.ti_mdbu_custom_dropdown_component.selectedIndex = this.$.ti_mdbu_custom_card_option_container.selectedOptions[0];
  if (this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 0 || this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 1) {
    this.$.ti_mdbu_custom_dropdown_component.fire('change');
  }
}

function navToUserSelectPage() {
  this.$.ti_basic_tuning_widget_tabcontainer.selectedIndex = 0;
}

function openMemoryViewer() {
  resetRegisterButtons.call(this);
  this.$.ti_mdbu_custom_mem_viewer_widget.openMemoryViewer();
}

function programMSPFirmware() {
  let programDeviceMenu = document.querySelector('#FileProgram');
  if(programDeviceMenu) {
    let menuAction = programDeviceMenu.querySelector('#menuAction');
    if(menuAction) {
      menuAction.click();
    }
  }
}

function writeEEPROM() {
  if (gc.connectionManager.status == "connected") {
    var obj = {
      "addr": 230,
      "size": 32
    };
    CustomCodec.prototype.readValue(obj)
      .then(function (regValue) {
        var regWriteCmd = 0x8A500000 | regValue;
        return CustomCodec.prototype.writeValue(obj, regWriteCmd)
          .then(function () {
              templateObj.showToastMsg('success', 'EEPROM write_cmd successful', 4);
            },
            function (err) {
              templateObj.showToastMsg('error', 'EEPROM write_cmd failed', 4);
            });
      }, function (err) {
        templateObj.showToastMsg('error', "EEPROM write failed.", 4);
      });
  }
}

function readEEPROM() {
  if (gc.connectionManager.status == "connected") {
    var obj = {
      "addr": 230,
      "size": 32
    };
    CustomCodec.prototype.readValue(obj)
      .then(function (regValue) {
        var regReadCmdValue = 0x40000000 | regValue;
        return CustomCodec.prototype.writeValue(obj, regReadCmdValue)
          .then(function () {
              templateObj.$.ti_widget_register_page._readAllRegistersClickHdlr();
              templateObj.showToastMsg('success', 'EEPROM read_cmd successful', 4);
            },
            function (err) {
              templateObj.showToastMsg('error', 'EEPROM read_cmd failed', 4);
            });
      }, function (err) {
        templateObj.showToastMsg('error', "Initial Read failed", 4);
      });
  }
}

function navToQuickStart() {
  this.$.ti_mdbu_custom_card_option_item1.selected = true;
  this.$.ti_mdbu_custom_card_option_item1.fire("cardOptionSelected", {
    'id': 'ti_mdbu_custom_card_option_item1'
  });
  this.$.ti_basic_tuning_nav_widget_button.fire('custom_button_click');
  this.$.ti_basic_tuning_custom_widget_vtabcontainer.selectedIndex = 0;
  this.$.ti_basic_tuning_custom_widget_tabcontainer.selectedIndex = 0;
}

function openFaultConfigDialog() {
  this.$.ti_widget_dialog.open();
}

function closeFaultConfigDialog() {
  this.$.ti_widget_dialog.close();
}

function moveToPrevTab(event) {
  event.detail.prevButtonClickHdlr();
}

function moveToNextTab(event) {
  event.detail.nextButtonClickHdlr();
}

function displayDraggableAndFloatinfo(event) {
  var helpInfoActiveIndexes = [2, 3, 4, 5];
  if (event.target.localName === 'ti-widget-vtabcontainer') {
    if (helpInfoActiveIndexes.indexOf(event.target.selectedIndex) != -1) {
      this.$.ti_mdbu_custom_floating_info.hidden = false;
      this.$.ti_mdbu_draggable_container.hidden = true;
      this.$.ti_right_panel_widget_container18.hidden = false;
    } else {
      this.$.ti_mdbu_custom_floating_info.hidden = true;
      this.$.ti_mdbu_draggable_container.hidden = true;
      this.$.ti_right_panel_widget_container18.hidden = true;
    }
  }
}

function selectedVtabChanged(event) {
  displayDraggableAndFloatinfo.call(this, event);

  if (event.target.selectedIndex === 6) {
    console.log("Serial port selected");
    document.querySelector("ti-service-serialio").openDialog()
    this.$.ti_widget_vtabcontainer.selectedIndex = this.prevSelectedIndex;
  } else {
    this.prevSelectedIndex = event.target.selectedIndex;
  }
}

function toggleMenu(event) {
  this.$.ti_widget_vtabcontainer.isExpanded = !this.$.ti_widget_vtabcontainer.isExpanded;
}

function readAllRegisters(event) {
  this.$.ti_widget_register_page._readAllRegistersClickHdlr();
}

function updateDroplistLabels(regBindings, droplistLabels) {
  var iterable = regBindings.srcBindRegField.widget ? regBindings.srcBindRegField.widget.options : regBindings.srcBindRegField.options;
  for (var i in iterable) {
    iterable[i].display = droplistLabels[i];
  }
  templateObj.refreshRegmap();
  for (var controlName of regBindings.destBindControls) {
    var controlElem = document.querySelector('#' + controlName);
    if (controlElem.localName === 'ti-mdbu-custom-dropdown-component') {
      controlElem.droplistLabels = droplistLabels.join('|');
    }
  }
}

function handleCSAModeChange(event) {
  var droplistLabels = event.currentTarget.checked ? ['Pin sense', '0.1 V', '0.2 V', '0.3 V', '0.4 V', '0.5 V', '0.6 V', '0.7 V', '0.8 V', '0.9 V', '1 V', '1.1 V', '1.2 V', '1.3 V', '1.4 V', '1.5 V'] : ['Pin sense', '0.2 V', '0.4 V', '0.6 V', '0.8 V', '1 V', '1.2 V', '1.4 V', '1.6 V', '1.8 V', '2 V', '2.2 V', '2.4 V', '2.6 V', '2.8 V', '3 V'];
  var regBindings = this.getHighlevelBindedControls('my_model', 'MOTOR_STARTUP1', 'IPD_CURR_THR');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'MOTOR_STARTUP2', 'OL_ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'FAULT_CONFIG1', 'ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'FAULT_CONFIG1', 'LOCK_ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
}

function changeDefaultApplication(event) {
    if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 0) {
        templateObj.$.ti_custom_widget_table.tableContentData = "ISD_CONFIG\\1\\1\\,\\0x00000080\\1\\1\\,\\0x6F04C140\\1\\1\n  \\:\\MOTOR_STARTUP1\\1\\1\\,\\0x00000082\\1\\1\\,\\0x35489195\\1\\1\n  \\:\\MOTOR_STARTUP2\\1\\1\\,\\0x00000084\\1\\1\\,\\0x1A295990\\1\\1\n  \\:\\CLOSED_LOOP1\\1\\1\\,\\0x00000086\\1\\1\\,\\0x0E3A0200\\1\\1\n  \\:\\CLOSED_LOOP2\\1\\1\\,\\0x00000088\\1\\1\\,\\0x02A6E4B0\\1\\1\n  \\:\\CLOSED_LOOP3\\1\\1\\,\\0x0000008A\\1\\1\\,\\0x4CC40101\\1\\1\n  \\:\\CLOSED_LOOP4\\1\\1\\,\\0x0000008C\\1\\1\\,\\0x000CE944\\1\\1\n  \\:\\CONST_SPEED\\1\\1\\,\\0x0000008E\\1\\1\\,\\0x00A00504\\1\\1\n  \\:\\CONST_PWR\\1\\1\\,\\0x00000090\\1\\1\\,\\0x5DC04C84\\1\\1\n  \\:\\150_DEG_TWO_PH_PROFILE\\1\\1\\,\\0x00000096\\1\\1\\,\\0x36DB6DA6\\1\\1\\\n  \\:\\150_DEG_THREE_PH_PROFILE\\1\\1\\,\\0x00000098\\1\\1\\,\\0x36DB6D80\\1\\1\\\n  \\:\\TRAP_CONFIG1\\1\\1\\,\\0x0000009A\\1\\1\\,\\0x054BA106\\1\\1\\\n  \\:\\TRAP_CONFIG2\\1\\1\\,\\0x0000009C\\1\\1\\,\\0x3A880000\\1\\1\\\n  \\:\\FAULT_CONFIG1\\1\\1\\,\\0x00000092\\1\\1\\,\\0x78F43025\\1\\1\\\n  \\:\\FAULT_CONFIG2\\1\\1\\,\\0x00000094\\1\\1\\,\\0x7447A009\\1\\1\\\n  \\:\\GD_CONFIG1\\1\\1\\,\\0x000000AC\\1\\1\\,\\0x1C440000\\1\\1\\\n  \\:\\GD_CONFIG2\\1\\1\\,\\0x000000AE\\1\\1\\,\\0x14000000\\1\\1\\\n  \\:\\PIN_CONFIG1\\1\\1\\,\\0x000000A4\\1\\1\\,\\0x2D720600\\1\\1\\\n  \\:\\PIN_CONFIG2\\1\\1\\,\\0x000000A6\\1\\1\\,\\0x080C0000\\1\\1\\\n  \\:\\DEVICE_CONFIG\\1\\1\\,\\0x000000A8\\1\\1\\,\\0x7FFF0000\\1\\1\\\n  \\:\\PERI_CONFIG\\1\\1\\,\\0x000000AA\\1\\1\\,\\0x00000000\\1\\1\\";
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 1) {
        templateObj.$.ti_custom_widget_table.tableContentData = "ISD_CONFIG\\1\\1\\,\\0x00000080\\1\\1\\,\\0x6F04C1C0\\1\\1\n  \\:\\MOTOR_STARTUP1\\1\\1\\,\\0x00000082\\1\\1\\,\\0x2BA89190\\1\\1\n  \\:\\MOTOR_STARTUP2\\1\\1\\,\\0x00000084\\1\\1\\,\\0x1A10B990\\1\\1\n  \\:\\CLOSED_LOOP1\\1\\1\\,\\0x00000086\\1\\1\\,\\0x08220200\\1\\1\n  \\:\\CLOSED_LOOP2\\1\\1\\,\\0x00000088\\1\\1\\,\\0x02A6E4B0\\1\\1\n  \\:\\CLOSED_LOOP3\\1\\1\\,\\0x0000008A\\1\\1\\,\\0x4CC40100\\1\\1\n  \\:\\CLOSED_LOOP4\\1\\1\\,\\0x0000008C\\1\\1\\,\\0x000CE944\\1\\1\n  \\:\\CONST_SPEED\\1\\1\\,\\0x0000008E\\1\\1\\,\\0x00A00504\\1\\1\n  \\:\\CONST_PWR\\1\\1\\,\\0x00000090\\1\\1\\,\\0x5DC04C84\\1\\1\n  \\:\\150_DEG_TWO_PH_PROFILE\\1\\1\\,\\0x00000096\\1\\1\\,\\0x36DB6DA6\\1\\1\\\n  \\:\\150_DEG_THREE_PH_PROFILE\\1\\1\\,\\0x00000098\\1\\1\\,\\0x36DB6D80\\1\\1\\\n  \\:\\TRAP_CONFIG1\\1\\1\\,\\0x0000009A\\1\\1\\,\\0x054BA106\\1\\1\\\n  \\:\\TRAP_CONFIG2\\1\\1\\,\\0x0000009C\\1\\1\\,\\0x62880000\\1\\1\\\n  \\:\\FAULT_CONFIG1\\1\\1\\,\\0x00000092\\1\\1\\,\\0x78F43025\\1\\1\\\n  \\:\\FAULT_CONFIG2\\1\\1\\,\\0x00000094\\1\\1\\,\\0x7447A009\\1\\1\\\n  \\:\\GD_CONFIG1\\1\\1\\,\\0x000000AC\\1\\1\\,\\0x1C440000\\1\\1\\\n  \\:\\GD_CONFIG2\\1\\1\\,\\0x000000AE\\1\\1\\,\\0x14000000\\1\\1\\\n  \\:\\PIN_CONFIG1\\1\\1\\,\\0x000000A4\\1\\1\\,\\0x2D720600\\1\\1\\\n  \\:\\PIN_CONFIG2\\1\\1\\,\\0x000000A6\\1\\1\\,\\0x080C0000\\1\\1\\\n  \\:\\DEVICE_CONFIG\\1\\1\\,\\0x000000A8\\1\\1\\,\\0x7FFF0000\\1\\1\\\n  \\:\\PERI_CONFIG\\1\\1\\,\\0x000000AA\\1\\1\\,\\0x00000000\\1\\1\\";
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 2) {
        templateObj.$.ti_custom_widget_table.tableContentData = "ISD_CONFIG\\1\\1\\,\\0x00000080\\1\\1\\,\\0x6F04C180\\1\\1\n  \\:\\MOTOR_STARTUP1\\1\\1\\,\\0x00000082\\1\\1\\,\\0x2F889192\\1\\1\n  \\:\\MOTOR_STARTUP2\\1\\1\\,\\0x00000084\\1\\1\\,\\0x1A1CF990\\1\\1\n  \\:\\CLOSED_LOOP1\\1\\1\\,\\0x00000086\\1\\1\\,\\0x09220200\\1\\1\n  \\:\\CLOSED_LOOP2\\1\\1\\,\\0x00000088\\1\\1\\,\\0x02A6E4B0\\1\\1\n  \\:\\CLOSED_LOOP3\\1\\1\\,\\0x0000008A\\1\\1\\,\\0x4CC40100\\1\\1\n  \\:\\CLOSED_LOOP4\\1\\1\\,\\0x0000008C\\1\\1\\,\\0x000CE944\\1\\1\n  \\:\\CONST_SPEED\\1\\1\\,\\0x0000008E\\1\\1\\,\\0x00A00504\\1\\1\n  \\:\\CONST_PWR\\1\\1\\,\\0x00000090\\1\\1\\,\\0x5DC04C84\\1\\1\n  \\:\\150_DEG_TWO_PH_PROFILE\\1\\1\\,\\0x00000096\\1\\1\\,\\0x36DB6DA6\\1\\1\\\n  \\:\\150_DEG_THREE_PH_PROFILE\\1\\1\\,\\0x00000098\\1\\1\\,\\0x36DB6D80\\1\\1\\\n  \\:\\TRAP_CONFIG1\\1\\1\\,\\0x0000009A\\1\\1\\,\\0x054BA106\\1\\1\\\n  \\:\\TRAP_CONFIG2\\1\\1\\,\\0x0000009C\\1\\1\\,\\0x52880000\\1\\1\\\n  \\:\\FAULT_CONFIG1\\1\\1\\,\\0x00000092\\1\\1\\,\\0x78F43025\\1\\1\\\n  \\:\\FAULT_CONFIG2\\1\\1\\,\\0x00000094\\1\\1\\,\\0x7447A009\\1\\1\\\n  \\:\\GD_CONFIG1\\1\\1\\,\\0x000000AC\\1\\1\\,\\0x1C440000\\1\\1\\\n  \\:\\GD_CONFIG2\\1\\1\\,\\0x000000AE\\1\\1\\,\\0x14000000\\1\\1\\\n  \\:\\PIN_CONFIG1\\1\\1\\,\\0x000000A4\\1\\1\\,\\0x2D720600\\1\\1\\\n  \\:\\PIN_CONFIG2\\1\\1\\,\\0x000000A6\\1\\1\\,\\0x080C0000\\1\\1\\\n  \\:\\DEVICE_CONFIG\\1\\1\\,\\0x000000A8\\1\\1\\,\\0x7FFF0000\\1\\1\\\n  \\:\\PERI_CONFIG\\1\\1\\,\\0x000000AA\\1\\1\\,\\0x00000000\\1\\1\\";
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 3) {
        templateObj.$.ti_custom_widget_table.tableContentData = "ISD_CONFIG\\1\\1\\,\\0x00000080\\1\\1\\,\\0x6F04C100\\1\\1\n  \\:\\MOTOR_STARTUP1\\1\\1\\,\\0x00000082\\1\\1\\,\\0x38C8D197\\1\\1\n  \\:\\MOTOR_STARTUP2\\1\\1\\,\\0x00000084\\1\\1\\,\\0x1A399990\\1\\1\n  \\:\\CLOSED_LOOP1\\1\\1\\,\\0x00000086\\1\\1\\,\\0x11466200\\1\\1\n  \\:\\CLOSED_LOOP2\\1\\1\\,\\0x00000088\\1\\1\\,\\0x02A6E4B0\\1\\1\n  \\:\\CLOSED_LOOP3\\1\\1\\,\\0x0000008A\\1\\1\\,\\0x4CC40101\\1\\1\n  \\:\\CLOSED_LOOP4\\1\\1\\,\\0x0000008C\\1\\1\\,\\0x000CE944\\1\\1\n  \\:\\CONST_SPEED\\1\\1\\,\\0x0000008E\\1\\1\\,\\0x00A00504\\1\\1\n  \\:\\CONST_PWR\\1\\1\\,\\0x00000090\\1\\1\\,\\0x5DC04C84\\1\\1\n  \\:\\150_DEG_TWO_PH_PROFILE\\1\\1\\,\\0x00000096\\1\\1\\,\\0x36DB6DA6\\1\\1\\\n  \\:\\150_DEG_THREE_PH_PROFILE\\1\\1\\,\\0x00000098\\1\\1\\,\\0x36DB6D80\\1\\1\\\n  \\:\\TRAP_CONFIG1\\1\\1\\,\\0x0000009A\\1\\1\\,\\0x054BA106\\1\\1\\\n  \\:\\TRAP_CONFIG2\\1\\1\\,\\0x0000009C\\1\\1\\,\\0x2A880000\\1\\1\\\n  \\:\\FAULT_CONFIG1\\1\\1\\,\\0x00000092\\1\\1\\,\\0x78F43025\\1\\1\\\n  \\:\\FAULT_CONFIG2\\1\\1\\,\\0x00000094\\1\\1\\,\\0x7947A009\\1\\1\\\n  \\:\\GD_CONFIG1\\1\\1\\,\\0x000000AC\\1\\1\\,\\0x1C440000\\1\\1\\\n  \\:\\GD_CONFIG2\\1\\1\\,\\0x000000AE\\1\\1\\,\\0x14000000\\1\\1\\\n  \\:\\PIN_CONFIG1\\1\\1\\,\\0x000000A4\\1\\1\\,\\0x2D720600\\1\\1\\\n  \\:\\PIN_CONFIG2\\1\\1\\,\\0x000000A6\\1\\1\\,\\0x080C0000\\1\\1\\\n  \\:\\DEVICE_CONFIG\\1\\1\\,\\0x000000A8\\1\\1\\,\\0x7FFF0000\\1\\1\\\n  \\:\\PERI_CONFIG\\1\\1\\,\\0x000000AA\\1\\1\\,\\0x00000000\\1\\1\\";
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 4) {
        templateObj.$.ti_custom_widget_table.tableContentData = "ISD_CONFIG\\1\\1\\,\\0x00000080\\1\\1\\,\\0x6EC4C000\\1\\1\n  \\:\\MOTOR_STARTUP1\\1\\1\\,\\0x00000082\\1\\1\\,\\0x3E07118B\\1\\1\n  \\:\\MOTOR_STARTUP2\\1\\1\\,\\0x00000084\\1\\1\\,\\0x3B52239C\\1\\1\n  \\:\\CLOSED_LOOP1\\1\\1\\,\\0x00000086\\1\\1\\,\\0x1F326200\\1\\1\n  \\:\\CLOSED_LOOP2\\1\\1\\,\\0x00000088\\1\\1\\,\\0x02A224B0\\1\\1\n  \\:\\CLOSED_LOOP3\\1\\1\\,\\0x0000008A\\1\\1\\,\\0x4D640111\\1\\1\n  \\:\\CLOSED_LOOP4\\1\\1\\,\\0x0000008C\\1\\1\\,\\0x000CE944\\1\\1\n  \\:\\CONST_SPEED\\1\\1\\,\\0x0000008E\\1\\1\\,\\0x00A00504\\1\\1\n  \\:\\CONST_PWR\\1\\1\\,\\0x00000090\\1\\1\\,\\0x5DC04C84\\1\\1\n  \\:\\150_DEG_TWO_PH_PROFILE\\1\\1\\,\\0x00000096\\1\\1\\,\\0x36DB6DA6\\1\\1\\\n  \\:\\150_DEG_THREE_PH_PROFILE\\1\\1\\,\\0x00000098\\1\\1\\,\\0x36DB6D80\\1\\1\\\n  \\:\\TRAP_CONFIG1\\1\\1\\,\\0x0000009A\\1\\1\\,\\0x050BA106\\1\\1\\\n  \\:\\TRAP_CONFIG2\\1\\1\\,\\0x0000009C\\1\\1\\,\\0x221C0000\\1\\1\\\n  \\:\\FAULT_CONFIG1\\1\\1\\,\\0x00000092\\1\\1\\,\\0x60F43025\\1\\1\\\n  \\:\\FAULT_CONFIG2\\1\\1\\,\\0x00000094\\1\\1\\,\\0x7487A009\\1\\1\\\n  \\:\\GD_CONFIG1\\1\\1\\,\\0x000000AC\\1\\1\\,\\0x1C440000\\1\\1\\\n  \\:\\GD_CONFIG2\\1\\1\\,\\0x000000AE\\1\\1\\,\\0x14000000\\1\\1\\\n  \\:\\PIN_CONFIG1\\1\\1\\,\\0x000000A4\\1\\1\\,\\0x2D720600\\1\\1\\\n  \\:\\PIN_CONFIG2\\1\\1\\,\\0x000000A6\\1\\1\\,\\0x08000000\\1\\1\\\n  \\:\\DEVICE_CONFIG\\1\\1\\,\\0x000000A8\\1\\1\\,\\0x7FFF0000\\1\\1\\\n  \\:\\PERI_CONFIG\\1\\1\\,\\0x000000AA\\1\\1\\,\\0x00000000\\1\\1\\";
    }
}

function showInitSettingsPopup(event) {
  if (this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 0 || this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 1) {
    this.$.ti_beginner_init_settings_dialog.open();
  }
}

function restoreDefaultSettings(event) {
  this.$.ti_beginner_init_settings_dialog.open();
}

function closeInitSettingsPopup(event) {
  this.$.ti_beginner_init_settings_dialog.close();
}

function hideConnectivityIssuePopup(event) {
  this.$.ti_connectivity_issue_dialog.close();
}

function enableBeginnerInitSettings(event) {

    var jsonfile = 'app/default_reg/Default.json';
    
    if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 0) {
        jsonfile = 'app/default_reg/Default.json';
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 1) {
        jsonfile = 'app/default_reg/Default Ultra Slow Acceleration for Pedestal & Ceiling Fans.json';
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 2) {
        jsonfile = 'app/default_reg/Default Slow Acceleration for Leaf Blowers.json';
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 3) {
        jsonfile = 'app/default_reg/Default Fast Acceleration for Robotic Vacuums.json';
    }
    else if (this.$.ti_adv_tuning_mdbu_custom_dropdown_component107.selectedIndex === 4) {
        jsonfile = 'app/default_reg/Default Ultra Fast Acceleration for Fuel Pumps.json';
    }
    
  gc.fileCache.readJsonFile(jsonfile).then((content) => {
    try {
      if (content) {
        templateObj.setRegisterData(JSON.stringify(content));
        templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded default registers.");
      }
    } catch (ex) {
      templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
    }
  });
  this.$.ti_beginner_init_settings_dialog.close();
}

function updateButtonStyles(self) {
  self.$.ti_widget_basic_read_registers.disabled = self.readingContinuously;
  self.$.ti_widget_adv_read_registers.disabled = self.readingContinuously;
  self.$.ti_widget_eval_read_registers.disabled = self.readingContinuously;

  self.$.ti_widget_basic_autoread_faultstatus_registers.disabled = self.readingContinuously;
  self.$.ti_widget_adv_autoread_faultstatus_registers.disabled = self.readingContinuously;
  self.$.ti_widget_eval_autoread_faultstatus_registers.disabled = self.readingContinuously;

  self.$.ti_widget_basic_autoread_motorstatus_registers.disabled = self.readingContinuously;
  self.$.ti_widget_adv_autoread_motorstatus_registers.disabled = self.readingContinuously;
  self.$.ti_widget_eval_autoread_motorstatus_registers.disabled = self.readingContinuously;

  self.$.ti_widget_basic_write_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_adv_write_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_eval_write_eeprom_button.disabled = self.readingContinuously;

  self.$.ti_widget_basic_read_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_adv_read_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_eval_read_eeprom_button.disabled = self.readingContinuously;

  self.$.ti_widget_write_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_read_eeprom_button.disabled = self.readingContinuously;
  self.$.ti_widget_register_page.$.read_register.disabled = self.readingContinuously;
  self.$.ti_widget_register_page.$.read_all_registers.disabled = self.readingContinuously;

  if (self.readingContinuously) {
    self.$.ti_widget_basic_read_cont.classList.add("custom-button-pressed");
    self.$.ti_widget_adv_read_cont.classList.add("custom-button-pressed");
    self.$.ti_widget_eval_read_cont.classList.add("custom-button-pressed");
  } else {
    self.$.ti_widget_basic_read_cont.classList.remove("custom-button-pressed");
    self.$.ti_widget_adv_read_cont.classList.remove("custom-button-pressed");
    self.$.ti_widget_eval_read_cont.classList.remove("custom-button-pressed");
  }

  if (self.readingFaultStatusRegistersContinuously) {
    self.$.ti_widget_basic_autoread_faultstatus_registers.classList.add("custom-button-pressed");
    self.$.ti_widget_adv_autoread_faultstatus_registers.classList.add("custom-button-pressed");
    self.$.ti_widget_eval_autoread_faultstatus_registers.classList.add("custom-button-pressed");
  } else {
    self.$.ti_widget_basic_autoread_faultstatus_registers.classList.remove("custom-button-pressed");
    self.$.ti_widget_adv_autoread_faultstatus_registers.classList.remove("custom-button-pressed");
    self.$.ti_widget_eval_autoread_faultstatus_registers.classList.remove("custom-button-pressed");
  }

  if (self.readingMotorStatusRegistersContinuously) {
    self.$.ti_widget_basic_autoread_motorstatus_registers.classList.add("custom-button-pressed");
    self.$.ti_widget_adv_autoread_motorstatus_registers.classList.add("custom-button-pressed");
    self.$.ti_widget_eval_autoread_motorstatus_registers.classList.add("custom-button-pressed");
  } else {
    self.$.ti_widget_basic_autoread_motorstatus_registers.classList.remove("custom-button-pressed");
    self.$.ti_widget_adv_autoread_motorstatus_registers.classList.remove("custom-button-pressed");
    self.$.ti_widget_eval_autoread_motorstatus_registers.classList.remove("custom-button-pressed");
  }
}

function disableAutoReadButtons(self) {
  self.$.ti_widget_basic_read_cont.disabled = true;
  self.$.ti_widget_adv_read_cont.disabled = true;
  self.$.ti_widget_eval_read_cont.disabled = true;
}

function enableAutoReadButtons(self) {
  self.$.ti_widget_basic_read_cont.disabled = false;
  self.$.ti_widget_adv_read_cont.disabled = false;
  self.$.ti_widget_eval_read_cont.disabled = false;
}

function readAllRegistersFromButton(event) {
  if (this.$.ti_widget_basic_read_registers.disabled) {
    return;
  }
  readAllRegisters.call(this, event);
}

function readRegistersContinuously(event, eventCall) {
  var self = this;
  if (self.$.ti_widget_basic_read_cont.disabled) {
    return;
  }
  if (eventCall !== false) {
    this.readingContinuously = !this.readingContinuously;
  }
  if (this.readingContinuously === false && this.readingInProgress === true) {
    disableAutoReadButtons(self);
  }
  if (this.readingContinuously === true) {
    this.readingFaultStatusRegistersContinuously = false;
    this.readingMotorStatusRegistersContinuously = false;
    updateButtonStyles(self);
    if (gc.connectionManager.status != "connected") {
      return;
    } else {
      readAllRegisters.call(self, event);
      self.readingInProgress = true;
      self.$.ti_widget_register_page.addEventListener("read_regs", function continuousRead(e) {
        var detailObj = e.detail;
        if (detailObj.statusType === "info") {
          self.$.ti_widget_register_page.removeEventListener("read_regs", continuousRead);
          if (self.readingContinuously === true) {
            readRegistersContinuously.call(self, event, false);
          }
          self.readingInProgress = false;
          enableAutoReadButtons(self);
        } else {
          self.$.ti_widget_register_page.removeEventListener("read_regs", continuousRead);
          self.readingContinuously = false;
          updateButtonStyles(self);
          self.readingInProgress = false;
          enableAutoReadButtons(self);
        }
      });
    }
  } else {
    updateButtonStyles(self);
  }
}

function updateButtonsBasedOnGraphState() {
  resetRegisterButtons.call(this);
}

function isdEnableHelpLinkClicked() {
  let mainVTabContainer = document.querySelector('#ti_widget_vtabcontainer');
  let guidedTuningMainVTabContainer = document.querySelector('#ti_basic_tuning_widget_tabcontainer');
  let guidedTuningVTabContainer = document.querySelector('#ti_basic_tuning_custom_widget_vtabcontainer');
  let guidedTuningTabContainer = document.querySelector('#ti_basic_tuning_custom_widget_tabcontainer');
  let container = document.querySelector('#ti_widget_container14')
  let accordion = document.querySelector('#ti_custom_widget_accordion4');
  mainVTabContainer.selectedIndex = 2;
  guidedTuningMainVTabContainer.selectedIndex = 1;
  guidedTuningVTabContainer.selectedIndex = 0;
  guidedTuningTabContainer.selectedIndex = 1;
  scrollTo(container, accordion);
  accordion.isExpanded = true;
}

function toggleClearFaultBit() {
    if (gc.databind.registry.getBinding('my_model.ALGO_CTRL1.CLR_FLT').getValue() == 1)
    {
        gc.databind.registry.getBinding('my_model.ALGO_CTRL1.CLR_FLT').setValue(0);
    }
    gc.databind.registry.getBinding('my_model.ALGO_CTRL1.CLR_FLT').setValue(1);
}

function autoReadMotorStatusRegistersClicked() {
  this.readingMotorStatusRegistersContinuously = !this.readingMotorStatusRegistersContinuously;
  updateButtonStyles(this);
  autoReadMotorStatusRegisters.call(this);
}

function autoReadFaultStatusRegistersClicked() {
  this.readingFaultStatusRegistersContinuously = !this.readingFaultStatusRegistersContinuously;
  updateButtonStyles(this);
  autoReadFaultStatusRegisters.call(this);
}

function autoReadMotorStatusRegisters() {
  if(this.readingMotorStatusRegistersContinuously) {
    let registerURIs = ['my_model.SYS_STATUS1',
                        'my_model.SYS_STATUS2',
                        'my_model.SYS_STATUS3'
    ];
    
    readRegisters(registerURIs).then(() => {
      return true;
    }).delay(600).then(() => {
      autoReadMotorStatusRegisters.call(this);
    });
  }
}

function autoReadFaultStatusRegisters() {
  if(this.readingFaultStatusRegistersContinuously) {
    let registerURIs = ['my_model.GATE_DRIVER_FAULT_STATUS',
                        'my_model.CONTROLLER_FAULT_STATUS',
                        'my_model.GD_CONFIG2'
    ];
    readRegisters(registerURIs).then(() => {
      return true;
    }).delay(600).then(() => {
      autoReadFaultStatusRegisters.call(this);
    });
  }
}

function setPlotType(event) {
    speed_profile_params.plot_type = gc.databind.registry.getBinding('my_model.SPEED_PROFILES1.SPEED_PROFILE_CONFIG').getValue();
    
    updatePlotDuty();
    updatePlotSpeed();
    
}

function dacout1_select(){
    var selected = this.$.ti_adv_tuning_mdbu_custom_dropdown_component145.selectedIndex;
    if (selected == 0)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x40C;
    else if (selected == 1)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x4D8;
    else if (selected == 2)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x4DA;
    else if (selected == 3)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x4DC;
    else if (selected == 4)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x59C;
    else if (selected == 5)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x4E8;
    else if (selected == 6)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x5AA;
    else if (selected == 7)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x6A6;
    else if (selected == 8)
        this.$.ti_mdbu_custom_numberinput_component13.value = 0x644;
}

function dacout2_select(){
    var selected = this.$.ti_adv_tuning_mdbu_custom_dropdown_component146.selectedIndex;
    if (selected == 0)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x40C;
    else if (selected == 1)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x4D8;
    else if (selected == 2)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x4DA;
    else if (selected == 3)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x4DC;
    else if (selected == 4)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x59C;
    else if (selected == 5)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x4E8;
    else if (selected == 6)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x5AA;
    else if (selected == 7)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x6A6;
    else if (selected == 8)
        this.$.ti_mdbu_custom_numberinput_component14.value = 0x644;
}
